Subject: Re: [PATCH] whitespace: symbolic links usually lack LF at the end

From: Patrick Steinhardt <[email-masked]>
Date: Fri, 6 Feb 2026 07:31:36 +0100

On Thu, Feb 05, 2026 at 07:50:55AM -0800, Junio C Hamano wrote:
> Patrick Steinhardt <[email-masked]> writes:
> 
> > I'd suggest that we only disable this check in case either:
> >
> >   - One side doesn't exist, the other is a symbolic link.
> >
> >   - Both sides are a symbolic link.
> 
> Hmm.  That is indeed a thoguht.  But we do not want to complain in
> text-to-symlink transition that postimage lacks the terminating LF,
> so the above rules may be a good start but will need further
> tweaking, I am afraid.

Ah, right. Only the other way around, when converting from LF to text.

> > Another question is whether we support symref targets that end in a
> > newline. I guess the answer is going to be some form of "yes", and in
> > that case we could of course loose some information. But honestly, this
> > is so much of an edge case that I don't really worry about it too much.
> 
> Do we track, apply and diff any symrefs?  I thought that we do not
> touch anything inside .git/ and symrefs live inside .git/refs/
> (except for .git/HEAD)?

Eh, I didn't mean symrefs here, but symbolic links :) Tools like ln(1)
seem to strip trailing newlines, but if you try hard enough you'll
probably be able to create symlinks that have a target with trailing
newline.

Patrick